
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  Part 1  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  SETUP & INITIALISIERUNG  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
globals [ INFINITY clock zerfall-hundrets zerfall-thirties zerfall-tens zerfall-fives zerfall-ones number-cliques 
          hnumber tnumber nnumber fnumber onumber total data1 data2 data3 data4 data5 datac cliquelist]

breed [ hundrets ahundret ]
breed [ thirties athirty ]
breed [ tens aten ]
breed [ fives afive ]
breed [ ones aone ]
breed [ enodes enode ]

breed [ partners partner ]


hundrets-own [ lifetime value ]
thirties-own [ lifetime value ]
tens-own     [ lifetime value ]
fives-own    [ lifetime value ]
ones-own     [ lifetime value ]
enodes-own [ vdistanz vorgaenger infoflow ]  


undirected-link-breed [ greenlinks greenlink ] 
undirected-link-breed [ whitelinks whitelink ]
undirected-link-breed [ ghostlinks ghostlink ]
undirected-link-breed [ streetlinks streetlink ]



;;;;;;;;;;;;;;;;;;;;;;;  1 OBERE EBENE  ;;;;;;;;;;;;;;;;;;;;;;;

to setup
  ca
  create-hundrets number-of-hundrets
  let x -24
  let y 24 
  ask hundrets
  [ ifelse fixed-position? [ set xcor x set ycor y setxyz x y zcor + 20 set x x + 12 set y y - 8]
  [ setxyz random-xcor random-ycor zcor + 20 ]
    set shape "circle"
    set color brown
    ifelse lifetime-random?
    [ set lifetime random 1000 ] [ set lifetime 1000 ]
    set size 1.5 ]

  create-thirties number-of-thirties
  set x  26
  set y  26
  ask thirties
  [ ifelse fixed-position? [ set xcor x set ycor y setxyz x y zcor + 20 set x x - 12 set y y - 8  ]
  [ setxyz random-xcor random-ycor zcor + 20]
    set shape "circle"
    set color orange
    ifelse lifetime-random?
    [ set lifetime random 300 ] [ set lifetime 300 ]
    set size 1.2 ]

  create-tens number-of-tens
  set x 0
  set y 28
  ask tens
  [ ifelse fixed-position? [ set xcor x set ycor y setxyz x y zcor + 20 set x x + 10 set y y - 15 ]
  [ setxyz random-xcor random-ycor zcor + 20]
    set shape "circle"
    set color red
    ifelse lifetime-random?
    [ set lifetime random 100 ] [ set lifetime 100 ]
    set size 0.9 ]

  create-fives number-of-fives
  set x 28
  set y 0
  ask fives
  [ifelse fixed-position? [ set xcor x set ycor y setxyz x y zcor + 20 set x x - 6 set y y + 15 ]
  [ setxyz random-xcor random-ycor zcor + 20]
    set shape "circle"
    set color yellow
    ifelse lifetime-random?
    [ set lifetime random 50 ] [ set lifetime 50 ]
    set size 0.9 ]

  create-ones number-of-ones
  set x -15
  set y 5
  ask ones
  [ ifelse fixed-position? [ set xcor x set ycor y setxyz x y zcor + 20 set x x + 6 set y y - 8 ]
  [ setxyz random-xcor random-ycor zcor + 20]
    set shape "circle"
    set color lime
    ifelse lifetime-random?
    [ set lifetime random 10 ] [ set lifetime 10 ]
    set size 0.5 ]
  
  set clock 0
  set hnumber number-of-hundrets
  set tnumber number-of-thirties
  set nnumber number-of-tens  
  set fnumber number-of-fives
  set onumber number-of-ones
  
  set data1 [ ]
  set data2 [ ]
  set data3 [ ]
  set data4 [ ]
  set data5 [ ]
  set datac [ ]

;;;;;;;;;;;;;;;;;;;;;;;  2 UNTERE EBENE  ;;;;;;;;;;;;;;;;;;;;;;;


let snodes ( turtle-set ones fives tens thirties hundrets )
let snumber count snodes
create-enodes snumber
set INFINITY 1000000

ask enodes 
   [ setxyz random-xcor random-ycor zcor - 20
     set shape "circle"
     set color grey
     set size 0.5 
     create-streetlink-with one-of other enodes ]
   
ask streetlinks [ set color blue
                  let mylist [ 5 10 25 50 75 100 ] 
                  set label one-of mylist ] 

ask snodes [ ifelse ghostlink-neighbor? one-of enodes 
              [ stop ]
              [ create-ghostlink-with one-of enodes with [count ghostlink-neighbors <= 0]  ]  ] 
hide-ghostlinks 
end


;;;;;;;;;;;;;;;;;;;;;;;  3 INITIALISIERUNG  ;;;;;;;;;;;;;;;;;;;;;;;


to initialize                    
   ask ones
      [ create-greenlink-with min-one-of hundrets [distance myself]   ;; der angefragte one erstellt link zu nchstgelegenen hundret
        create-greenlink-with min-one-of fives [distance myself] 
        set value lifetime + count greenlink-neighbors ]    ;; der angefragte one erstellt link zu nchstgelegenen five                                                                               
     ask fives
      [ create-greenlink-with min-one-of tens [distance myself] 
        create-greenlink-with min-one-of thirties [distance myself] 
        set value lifetime + count greenlink-neighbors ]
     ask tens
      [ create-greenlink-with min-one-of hundrets [distance myself] 
        set value lifetime + count greenlink-neighbors ]   
     ask thirties
      [ create-greenlink-with min-one-of hundrets [distance myself]
        create-greenlink-with min-one-of other thirties [distance myself] 
        set value lifetime + count greenlink-neighbors ]  ;; der angefragte thirty erstellt link zu nchstgelegenen hundret
   display
   if layout? [ layout ] 
end


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  Part 2 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; OPTIMALE PARTNER FINDEN ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to optimize

ask ones             ;; jeder one wird einzeln durchgefragt
  [ let caller self      ;; der angefragte rote nennt sich ab jetzt "caller"
    let medvalue 0       ;; die variable "medvalue" wird eingefhrt und auf 0 gesetzt
    ask fives            ;; caller fragt jetzt nacheinander alle fives ab
       [ set medvalue value + medvalue ]   ;; fr den angefragten weissen wird medvalue = anzahl der links am weissen node + medvalue (0 im ersten durchlauf) gesetzt
    set medvalue (medvalue / count fives)                ;; nachfolgend wird medvalue als arithmethisches mittel der medvalues aller weissen gesetzt
    ask fives                                               ;; caller fragt jetzt nochmal nacheinander alle fives ab                      
       [ if ( distance caller < 20 ) and ( value > medvalue )    ;; wenn angefragter five in entfernung < 10 liegt & seine value > arithmethischen mittel
                 [ create-greenlink-with caller ] ]              ;; dann wird von ihm ein greenlink zum caller erstellt 
    ask greenlinks [ set color green ]           
  ]
     
ask ones
  [ let caller self
    let medvalue 0
    ask hundrets   
       [ set medvalue value + medvalue ]
    set medvalue (medvalue / count hundrets) 
    ask hundrets                       
       [ if ( distance caller < 80 ) and ( value > medvalue ) 
                 [ create-greenlink-with caller ] ]
    ask greenlinks [ set color green ]           
  ]

ask fives
  [ let caller self
    let medvalue 0
    ask tens   
       [ set medvalue value + medvalue ]
    set medvalue (medvalue / count tens) 
    ask tens                       
       [ if ( distance caller < 20 ) and ( value > medvalue ) 
                 [ create-greenlink-with caller ] ]
    ask greenlinks [ set color green ]           
  ]

ask fives
  [ let caller self
    let medvalue 0
    ask thirties   
       [ set medvalue value + medvalue ]
    set medvalue (medvalue / count thirties) 
    ask thirties                      
       [ if ( distance caller < 20 ) and ( value > medvalue ) 
                 [ create-greenlink-with caller ] ]
    ask greenlinks [ set color green ]           
  ]

ask tens
  [ let caller self
    let medvalue 0
    ask hundrets  
       [ set medvalue value + medvalue ]
    set medvalue (medvalue / count hundrets) 
    ask hundrets                   
       [ if ( distance caller < 80 ) and ( value > medvalue ) 
                 [ create-greenlink-with caller ] ]
    ask greenlinks [ set color green ]           
  ]

ask thirties
  [ let caller self
    let medvalue 0
    ask hundrets  
       [ set medvalue value + medvalue ]
    set medvalue (medvalue / count hundrets) 
    ask hundrets                     
       [ if ( distance caller < 100 ) and ( value > medvalue ) 
                 [ create-greenlink-with caller ] ]
    ask greenlinks [ set color green ]           
  ]
  
ask thirties
  [ let caller self
    let medvalue 0
    let othirties other thirties
    ask othirties  
       [ set medvalue value + medvalue ]
    set medvalue (medvalue / count thirties) 
    ask othirties                     
       [ if ( distance caller < 4 ) and ( value > medvalue ) 
                 [ create-greenlink-with caller ] ]
    ask greenlinks [ set color green ]           
  ]

ask whitelinks [die]

end



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  Part 3 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;   CLIQUEN FINDEN    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

  
to find-cliques 

let snodes ( turtle-set ones fives tens thirties hundrets )
ask snodes
    [ let caller self
      let specials greenlink-neighbors
      ask specials 
          [ let ncaller self
            ask other specials 
            [ if greenlink-neighbor? ncaller [ ask greenlink-with caller [ set color yellow set thickness 0.3 ]  ] 
            ]    
         ]
     ]
end
     


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  Part 4 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; LEBENSZEIT LUFT AB ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to go
  
 if ticks >= maximum-runtime [ stop ]
 ask ones
     [ set lifetime lifetime - 1
       set value lifetime + count greenlink-neighbors
       set label value
       if lifetime <= 0 [ check-value-ones ] ]
 ask fives
     [ set lifetime lifetime - 1
       set value lifetime + count greenlink-neighbors
       set label value
       if lifetime <= 0 [ check-value-fives ] ]
 ask tens
     [ set lifetime lifetime - 1
       set value lifetime + count greenlink-neighbors
       set label value
       if lifetime <= 0 [ check-value-tens ] ]
 ask thirties
     [ set lifetime lifetime - 1
       set value lifetime + count greenlink-neighbors
       set label value
       if lifetime <= 0 [ check-value-thirties ] ]
 ask hundrets
     [ set lifetime lifetime - 1
       set value lifetime + count greenlink-neighbors
       set label value
       if lifetime <= 0 [ check-value-hundrets ] ]
     
     
  optimize
  find-cliques
  check-turan
 tick
 set clock clock + 1
 if clock = clock-period
 [
 ;;;;;;;;;;;;;;;;;;;;;;;  Zerfallsrate berechnen ;;;;;;;;;;;;;;;;;;;;;;;;;;;
 if count hundrets != 0 and count thirties != 0 and count tens != 0 and count fives != 0 and count ones != 0 [
 set zerfall-hundrets ( ( ln (count hundrets) - ln hnumber )  / clock-period * -1 )
 set data1 lput zerfall-hundrets data1
 set zerfall-thirties ( ( ln (count thirties) - ln tnumber )  / clock-period * -1 )
 set data2 lput zerfall-thirties data2
 set zerfall-tens     ( ( ln (count tens) - ln nnumber )  / clock-period * -1 )
 set data3 lput zerfall-tens data3
 set zerfall-fives ( ( ln (count fives) - ln fnumber )  / clock-period * -1 )
 set data4 lput zerfall-thirties data4
 set zerfall-ones ( ( ln (count ones) - ln onumber )  / clock-period * -1 )
 set data5 lput zerfall-thirties data5 ]
 set number-cliques (count links with [color = yellow] / 3 )
 set datac lput number-cliques datac
 
 set hnumber count hundrets
 set tnumber count thirties
 set nnumber count tens
 set fnumber count fives
 set onumber count ones
 
 set clock 0 ]
 
  if plot? [ do-plots ]
end


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  Part 5 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; AKTUELLER VALUE WIRD BERECHNET ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to check-value-ones  
ifelse count ones > 0 and count greenlink-neighbors > 0
  [ let medneighbors 0
    ask ones
       [ set medneighbors count greenlink-neighbors + medneighbors ]
    set medneighbors (medneighbors / count ones)  
    ask ones
     [ if count greenlink-neighbors >= medneighbors  [ set lifetime lifetime + 10 
       ask ghostlink-neighbors [ let partner self 
       dijkstra ]]
       if lifetime <= 0 [ die ] ] 
  ] 
  [ die ]
end
  
to check-value-fives  
ifelse count fives > 0 and count greenlink-neighbors > 0
  [ let medneighbors 0
    ask fives
       [ set medneighbors count greenlink-neighbors + medneighbors ]
    set medneighbors (medneighbors / count fives )  
    ask fives
     [ if count greenlink-neighbors >= medneighbors  
     [ set lifetime lifetime + 50 
       ask ghostlink-neighbors [ let partner self 
       dijkstra ]]
       if lifetime <= 0 [ die ] ] 
  ]
[ die ]
end
  
to check-value-tens 
ifelse count tens > 0 and count greenlink-neighbors > 0
  [ let medneighbors 0
    ask tens
       [ set medneighbors count greenlink-neighbors + medneighbors ]
    set medneighbors (medneighbors / count tens)  
    ask tens
     [ if count greenlink-neighbors >= medneighbors  [ set lifetime lifetime + 100 
       ask ghostlink-neighbors [ let partner self 
       dijkstra ]] 
       if lifetime <= 0 [ die ] ]
  ]
  [ die ]
end

to check-value-thirties 
ifelse count thirties > 0 and count greenlink-neighbors > 0
  [ let medneighbors 0
    ask thirties
       [ set medneighbors count greenlink-neighbors + medneighbors ]
    set medneighbors (medneighbors / count thirties)  
    ask thirties
     [ if count greenlink-neighbors >= medneighbors  [ set lifetime lifetime + 300 
       ask ghostlink-neighbors [ let partner self 
       dijkstra ] ] 
       if lifetime <= 0 [ die ] ] 
  ]
  [ die ]
end

to check-value-hundrets 
ifelse count hundrets > 0 and count greenlink-neighbors > 0
  [ let medneighbors 0
    ask hundrets
       [ set medneighbors count greenlink-neighbors + medneighbors ]
    set medneighbors (medneighbors / count hundrets)  
    ask hundrets
     [ if count greenlink-neighbors >= medneighbors  [ set lifetime lifetime + 1000 
       ask ghostlink-neighbors [ let partner self 
       dijkstra ]]
       if lifetime <= 0 [ die ] ] 
  ]
  [ die ]
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  Part 6 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;   PLOT-FUNKTIONEN  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to do-plots
  set-current-plot "Totals"
  set-current-plot-pen "Hundrets"
    if pl-totals-hund? [   plot count hundrets ]
  set-current-plot-pen "Thirties"
    if pl-totals-thir? [   plot count thirties ]
  set-current-plot-pen "Tens"
    if pl-totals-tens? [   plot count tens ]
  set-current-plot-pen "Fives"
    if pl-totals-five? [   plot count fives ]
  set-current-plot-pen "Ones"
    if pl-totals-ones? [   plot count ones ]
  set-current-plot-pen "cliques"
  plot number-cliques

  
  set-current-plot "Zerfallsraten"
  set-current-plot-pen "Hundrets"
    if pl-zerf-hund? [   plot zerfall-hundrets ]
  set-current-plot-pen "Thirties"
    if pl-zerf-thir? [   plot zerfall-thirties ]
  set-current-plot-pen "Tens"
    if pl-zerf-tens? [   plot zerfall-tens ]
  set-current-plot-pen "Fives"
    if pl-zerf-five? [   plot zerfall-fives ]
  set-current-plot-pen "Ones"
    if pl-zerf-ones? [   plot zerfall-ones ]
    
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  Part 7 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;   KORRELATIONSFUNKTION  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to correlate

 let q correlation-value
 let ilength maximum-runtime
 
 let sumxi 0
 let sumxi2 0
 let sumyi2 0
 let i 0
 
 if ilength > 0 [ repeat ilength 
                     [ set sumxi sumxi + ( item i data1 * ( item i datac + q ) )
                       set sumxi2 sumxi2 + (item i data1 ^ 2)
                       set sumyi2 sumyi2 + ( (item i datac + q ) ^ 2 )
                       set i i + 1  ]
                       let corrq1 sumxi / sqrt ( sumxi2 * sumyi2 )
                       output-print "Die Korrelationskoeffizienten sind:"
                       output-print precision corrq1 3 
 set sumxi 0
 set sumxi2 0
 set sumyi2 0
 set i 0
                  repeat ilength
                       [ set sumxi sumxi + ( item i data2 * ( item i datac + q ) )
                       set sumxi2 sumxi2 + (item i data2 ^ 2)
                       set sumyi2 sumyi2 + ( (item i datac + q ) ^ 2 )
                       set i i + 1  ]
                       let corrq2 sumxi / sqrt ( sumxi2 * sumyi2 )
                       output-print precision corrq2 3 
 set sumxi 0
 set sumxi2 0
 set sumyi2 0
 set i 0
                  repeat ilength
                       [ set sumxi sumxi + ( item i data3 * ( item i datac + q ) )
                       set sumxi2 sumxi2 + (item i data3 ^ 2)
                       set sumyi2 sumyi2 + ( (item i datac + q ) ^ 2 )
                       set i i + 1  ]
                       let corrq3 sumxi / sqrt ( sumxi2 * sumyi2 )
                       output-print precision corrq3 3 
 set sumxi 0
 set sumxi2 0
 set sumyi2 0
 set i 0
                  repeat ilength
                       [ set sumxi sumxi + ( item i data4 * ( item i datac + q ) )
                       set sumxi2 sumxi2 + (item i data4 ^ 2)
                       set sumyi2 sumyi2 + ( (item i datac + q ) ^ 2 )
                       set i i + 1  ]
                       let corrq4 sumxi / sqrt ( sumxi2 * sumyi2 )
                       output-print precision corrq4 3 
 
 set sumxi 0
 set sumxi2 0
 set sumyi2 0
 set i 0
                  repeat ilength
                       [ set sumxi sumxi + ( item i data5 * ( item i datac + q ) )
                       set sumxi2 sumxi2 + (item i data5 ^ 2)
                       set sumyi2 sumyi2 + ( (item i datac + q ) ^ 2 )
                       set i i + 1  ]
                       let corrq5 sumxi / sqrt ( sumxi2 * sumyi2 )
                       output-print precision corrq5 3  
 

 
 ]
  
 end













;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  Part 8 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;   DIJKSTRA-PROZEDUR  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



to dijkstra
let partner self
let snodes ( turtle-set ones fives tens thirties hundrets )
;;;;;;;;;;;;;;;;;;;;;;;;;;; 1.INITIALISIERUNG DER VARIABLEN ;;;;;;;;;;;;;;;;
  let qlist[]
  ask enodes
       [ set vdistanz INFINITY 
         set vorgaenger nobody
         ;schreibe alle turtles in die liste qlist
         set qlist lput self qlist
       ]  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 2.STARTKNOTEN SETZEN ;;;;;;;;;;;;;;;;;;;;;;

  ask partner [set vorgaenger self 
                 set vdistanz 0
                 ]



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 3.ALGORITHMUS ;;;;;;;;;;;;;;;;;;;;;;;;;;;;

  while [ not empty? qlist ]                 
  [ 
   ;Finde turtle mit minimaler "vdistance" in qlist
   let u min-one-of turtle-set qlist [vdistanz]

   ask u
   [
      if vdistanz = INFINITY [ set qlist [] stop ]
      set color green
      set qlist remove u qlist
      ask streetlink-neighbors[
        let newValue (([vdistanz] of u) + [ label ] of streetlink-with u)
        if (newValue < vdistanz)
        [
          set vdistanz newValue
          set vorgaenger u
        ]
      ]
   ]
  ]



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 4.ANZEIGEN BERECHNTER WERTE & RCKKOPPLUNG  ;;;;;;;;;;;;;
  ; frbe startknoten rot
  ask partner [ set color red 
                set size size + 0.1]
  ; zeige die distanz der knoten als label an
  ask enodes [ set label vdistanz 
               if self != partner
                  [ if vdistanz < INFINITY 
                      [ let widerstand vdistanz / 100
                        set infoflow  100 - ( 100 * widerstand )
                        if  infoflow > 0 [ set color red + (infoflow / 10 ) ]
                        ask snodes [ if ghostlink-neighbor? self [ set value value + ( value * infoflow ) ] ] ] ] ]
  ask max-one-of enodes [vdistanz] [ if vdistanz != INFINITY [set color orange ] ]

end





;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  Part 7 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;   ZUSATZFUNKTIONEN  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to fill-fives
 create-fives 20
  ask fives
  [ setxy random-xcor random-ycor
    set shape "circle"
    set color yellow
    set lifetime 50
    set size 0.9 
    create-whitelink-with min-one-of tens [distance myself] 
    create-whitelink-with min-one-of thirties [distance myself] 
    set value lifetime + count whitelink-neighbors ]
end  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to layout
   repeat 20 [
   layout-spring ones links 2 8 8
   layout-spring fives links 2 8 8
   layout-spring tens links 2 8 8
   layout-spring thirties links 2 8 8
   layout-spring hundrets links 2 8 8
   display ]
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                          
to wiggle-nodes
  ask enodes [ if infoflow > 0 [fd infoflow / 1000 left random 45 tilt-up random 45 ]]
  display
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to hide-ghostlinks 
  ifelse hide-ghostlinks? [ ask ghostlinks [hide-link ] ] [ ask ghostlinks [show-link ]]
end 


to check-turan
set cliquelist [ ]
let maxcliquesize 6
let yellowlinks links with [color = yellow]
let m count yellowlinks
ask turtles [ if is-link? self and is-link? color = yellow
                                            [set cliquelist fput self cliquelist] 
let n length cliquelist
if m > ( ( n ^ 2 ) *  ( ( maxcliquesize - 2) / (maxcliquesize - 1 ) ) ) / 2 [  ] ] 
end

;;; Copyright Axel Haeusler 2010 - Dieses Programm ist Bestandtteil der Dissertation Stadtmonitoring plus am Geographischen Institut der Universitt Bonn ! ;;;;;;;
;;; Kopien und Verffentlichung bedrfen der Zustimmung des Autors! ;;;;;
@#$#@#$#@
GRAPHICS-WINDOW
0
0
606
627
40
40
7.361
1
10
1
1
1
0
1
1
1
-40
40
-40
40
-40
40
1
0
1
ticks

BUTTON
5
257
71
290
NIL
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL

BUTTON
79
257
149
290
NIL
initialize
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL

SWITCH
33
594
149
627
layout?
layout?
1
1
-1000

BUTTON
43
297
106
330
NIL
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL

BUTTON
33
554
150
587
NIL
find-cliques
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL

BUTTON
33
515
149
548
NIL
wiggle-nodes
T
1
T
OBSERVER
NIL
NIL
NIL
NIL

SLIDER
3
10
184
43
number-of-hundrets
number-of-hundrets
0
100
12
1
1
NIL
HORIZONTAL

SLIDER
3
44
185
77
number-of-thirties
number-of-thirties
0
100
30
1
1
NIL
HORIZONTAL

SLIDER
3
78
186
111
number-of-tens
number-of-tens
0
100
20
1
1
NIL
HORIZONTAL

SLIDER
3
112
187
145
number-of-fives
number-of-fives
0
100
30
1
1
NIL
HORIZONTAL

SLIDER
3
146
188
179
number-of-ones
number-of-ones
0
100
20
1
1
NIL
HORIZONTAL

SWITCH
245
583
406
616
hide-ghostlinks?
hide-ghostlinks?
0
1
-1000

SWITCH
4
183
188
216
fixed-position?
fixed-position?
1
1
-1000

SWITCH
4
217
189
250
lifetime-random?
lifetime-random?
0
1
-1000

SLIDER
4
338
181
371
interaction-radius-hundrets
interaction-radius-hundrets
0
100
40
1
1
NIL
HORIZONTAL

SLIDER
4
372
181
405
interaction-radius-thirties
interaction-radius-thirties
0
100
30
1
1
NIL
HORIZONTAL

SLIDER
4
405
181
438
interaction-radius-tens
interaction-radius-tens
0
100
20
1
1
NIL
HORIZONTAL

SLIDER
4
439
181
472
interaction-radius-fives
interaction-radius-fives
0
100
30
1
1
NIL
HORIZONTAL

SLIDER
4
473
181
506
interaction-radius-othirties
interaction-radius-othirties
0
100
20
1
1
NIL
HORIZONTAL

SLIDER
240
15
412
48
correlation-value
correlation-value
-5
5
0
0.1
1
NIL
HORIZONTAL

SLIDER
240
48
412
81
clock-period
clock-period
1
50
1
1
1
NIL
HORIZONTAL

SLIDER
240
82
412
115
maximum-runtime
maximum-runtime
0
2000
500
1
1
NIL
HORIZONTAL

SLIDER
240
116
413
149
value-i
value-i
0
10
2
1
1
NIL
HORIZONTAL

SWITCH
244
176
400
209
plot?
plot?
0
1
-1000

SWITCH
245
210
400
243
pl-totals-hund?
pl-totals-hund?
0
1
-1000

SWITCH
245
244
400
277
pl-totals-thir?
pl-totals-thir?
0
1
-1000

SWITCH
245
278
400
311
pl-totals-tens?
pl-totals-tens?
0
1
-1000

SWITCH
245
312
400
345
pl-totals-five?
pl-totals-five?
0
1
-1000

SWITCH
245
346
400
379
pl-totals-ones?
pl-totals-ones?
0
1
-1000

SWITCH
245
382
400
415
pl-zerf-hund?
pl-zerf-hund?
0
1
-1000

SWITCH
245
416
400
449
pl-zerf-thir?
pl-zerf-thir?
0
1
-1000

SWITCH
245
450
400
483
pl-zerf-tens?
pl-zerf-tens?
0
1
-1000

SWITCH
245
485
400
518
pl-zerf-five?
pl-zerf-five?
0
1
-1000

SWITCH
245
520
400
553
pl-zerf-ones?
pl-zerf-ones?
0
1
-1000

PLOT
434
24
841
174
Totals
time
totals
0.0
10.0
0.0
10.0
true
true
PENS
"Hundrets" 1.0 0 -6459832 true
"Thirties" 1.0 0 -955883 true
"Tens" 1.0 0 -2674135 true
"Fives" 1.0 0 -1184463 true
"Ones" 1.0 0 -13840069 true
"cliques" 1.0 0 -16777216 true

PLOT
434
175
841
384
Zerfallsraten
time
zerfall
0.0
10.0
0.0
0.0050
true
true
PENS
"hundrets" 1.0 0 -6459832 true
"thirties" 1.0 0 -955883 true
"tens" 1.0 0 -2674135 true
"fives" 1.0 0 -1184463 true
"ones" 1.0 0 -13840069 true

OUTPUT
434
384
841
438
12

BUTTON
434
448
841
481
NIL
correlate
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL

TEXTBOX
438
497
812
565
ACHTUNG!\nDie Bestimmung des Korrelationskoeffizienten mit \"Correlate\" kann nur nach Ablauf der Simulation und derzeit nur bei einer \"clock-period\" von 1 verwendet werden.
11
0.0
1

@#$#@#$#@
WHAT IS IT?
-----------
This section could give a general understanding of what the model is trying to show or explain.


HOW IT WORKS
------------
This section could explain what rules the agents use to create the overall behavior of the model.


HOW TO USE IT
-------------
This section could explain how to use the model, including a description of each of the items in the interface tab.


THINGS TO NOTICE
----------------
This section could give some ideas of things for the user to notice while running the model.


THINGS TO TRY
-------------
This section could give some ideas of things for the user to try to do (move sliders, switches, etc.) with the model.


EXTENDING THE MODEL
-------------------
This section could give some ideas of things to add or change in the procedures tab to make the model more complicated, detailed, accurate, etc.


NETLOGO FEATURES
----------------
This section could point out any especially interesting or unusual features of NetLogo that the model makes use of, particularly in the Procedures tab.  It might also point out places where workarounds were needed because of missing features.


RELATED MODELS
--------------
This section could give the names of models in the NetLogo Models Library or elsewhere which are of related interest.


CREDITS AND REFERENCES
----------------------
This section could contain a reference to the model's URL on the web if it has one, as well as any other necessary credits or references.
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
0
Rectangle -7500403 true true 151 225 180 285
Rectangle -7500403 true true 47 225 75 285
Rectangle -7500403 true true 15 75 210 225
Circle -7500403 true true 135 75 150
Circle -16777216 true false 165 76 116

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 3D 4.1
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 1.0 0.0
0.0 1 1.0 0.0
0.2 0 1.0 0.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
0
@#$#@#$#@
