//
// Copyright (c) 2007 Eric Russell. All rights reserved.
//

package org.myworldgis.netlogo;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.Reader;
import java.text.ParseException;
import org.myworldgis.projection.ProjectionFormat;
import org.nlogo.api.*;


/**
 * 
 */
public final strictfp class LoadCoordinateSystem extends GISExtension.Command {
    
    //--------------------------------------------------------------------------
    // GISExtension.Command implementation
    //--------------------------------------------------------------------------
    
    /** */
    public String getAgentClassString() {
        return "O";
    }

    /** */
    public Syntax getSyntax() {
        return Syntax.commandSyntax(new int[] { Syntax.TYPE_STRING });
    }

    /** */
    public void performInternal (Argument args[], Context context) 
            throws ExtensionException, IOException, LogoException, ParseException {
        String prjFile = context.attachCurrentDirectory(args[0].getString());
        Reader in = new BufferedReader(new FileReader(prjFile));
        try {
            GISExtension.getState().setProjection(ProjectionFormat.getInstance().parseProjection(in),
                                                  context);
        } finally {
            in.close();
        }
    }
}
